/*
 * $Id: //depot/prod/spl/main/snapcenter-cli/src/main/java/com/netapp/snapcenter/cli/command/HelpCommand.java#1 $
 *
 * Copyright (c) 2015 NetApp, Inc.
 * All rights reserved.
 */

package com.netapp.snapcenter.cli.command;

import java.util.ArrayList;
import java.util.List;

import org.apache.commons.lang3.StringUtils;

import com.beust.jcommander.Parameter;
import com.beust.jcommander.Parameters;
import com.netapp.common.logging.MessageBundle;
import com.netapp.snapcenter.cli.exception.CLIException;
import com.netapp.snapcenter.cli.logging.CLIMsgKey;
import com.netapp.snapcenter.cli.utils.CLIUtils;

/*
 * Help command for CLI.
 * 
 * usage: snapcenter-cli help <command>
 *
 * This will display the help for the command specified.
 * If no command is specified then it will simply lists the available commands.
 *
 */
@Parameters
public class HelpCommand implements CommandInterface {

    private static final String COMMANDNAME = MessageBundle
            .localizeMessage(CLIMsgKey.CLI_HELP_COMMAND_NAME);

    @Parameter
    private List<String> commands = new ArrayList<>();

    @Override
    public String getCommandName() {
        return COMMANDNAME;
    }

    @Override
    public void run() throws CLIException {
        // no op
    }

    public String getCommandNameForHelp() {
        if (CLIUtils.isNullOrEmptyCollection(commands)) {
            return StringUtils.EMPTY;
        } else {
            return commands.iterator().next();
        }
    }

    public void setCommands(List<String> commands) {
        this.commands = commands;
    }

    public List<String> getCommands() {
        return commands;
    }

}