/*
 * $Id: //depot/prod/spl/main/snapcenter-cli/src/main/java/com/netapp/snapcenter/cli/command/parameters/SMOBackupPolicyParameters.java#1 $
 * 
 * Copyright (c) 2015 NetApp, Inc.
 * All rights reserved.
 */

package com.netapp.snapcenter.cli.command.parameters;

import com.beust.jcommander.Parameter;
import com.beust.jcommander.Parameters;
import com.netapp.snapcenter.cli.contracts.OracleArchiveLogBackupRetentionType;
import com.netapp.snapcenter.cli.contracts.OracleBackupScope;
import com.netapp.snapcenter.cli.contracts.OracleBackupType;
import com.netapp.snapcenter.cli.contracts.OraclePruneArchiveLogDestinationType;
import com.netapp.snapcenter.cli.contracts.OraclePruneArchiveLogType;

@Parameters(resourceBundle = "snapcenter-cli")
public class SMOBackupPolicyParameters implements ParameterInterface {

    @Parameter(names = { "-OracleBackupType" }, descriptionKey = "cli.smpolicy.command.oracleBackupType.option.description")
    private OracleBackupType oracleBackupType;

    @Parameter(names = { "-OracleBackupScope" }, descriptionKey = "cli.smpolicy.command.oracleBackupScope.option.description")
    private OracleBackupScope oracleBackupScope;

    @Parameter(names = { "-OracleSkipPDBSaveState" }, descriptionKey = "cli.smpolicy.command.oracleSkipPDBSaveState.option.description")
    private boolean oracleSkipPDBSaveState;

    @Parameter(names = { "-OraclePruneArchiveLog" }, descriptionKey = "cli.smpolicy.command.oraclePruneArchiveLog.option.description")
    private boolean oraclePruneArchiveLog;

    @Parameter(names = { "-OraclePruneArchiveLogType" }, descriptionKey = "cli.smpolicy.command.oraclePruneArchiveLogType.option.description")
    private OraclePruneArchiveLogType oraclePruneArchiveLogType;

    @Parameter(names = { "-OraclePruneArchiveLogOlderThanDays" }, descriptionKey = "cli.smpolicy.command.oraclePruneArchiveLogOlderThanDays.option.description")
    private Double oraclePruneArchiveLogOlderThanDays;

    @Parameter(names = { "-OraclePruneArchiveLogDestinationType" }, descriptionKey = "cli.smpolicy.command.oraclePruneArchiveLogDestinationType.option.description")
    private OraclePruneArchiveLogDestinationType oraclePruneArchiveLogDestinationType;

    @Parameter(names = { "-OracleDeleteArchiveLogBackup" }, descriptionKey = "cli.smpolicy.command.oracleDeleteArchiveLogBackup.option.description")
    private boolean oracleDeleteArchiveLogBackup;

    @Parameter(names = { "-OracleArchiveLogBackupRetentionType" }, descriptionKey = "cli.smpolicy.command.oracleArchiveLogBackupRetentionType.option.description")
    private OracleArchiveLogBackupRetentionType oracleArchiveLogBackupRetentionType;

    @Parameter(names = { "-OracleDeleteArchiveLogBackupCounts" }, descriptionKey = "cli.smpolicy.command.oracleDeleteArchiveLogBackupCounts.option.description")
    private Integer oracleDeleteArchiveLogBackupCounts;

    @Parameter(names = { "-OracleDeleteArchiveLogBackupDays" }, descriptionKey = "cli.smpolicy.command.oracleDeleteArchiveLogBackupDays.option.description")
    private Double oracleDeleteArchiveLogBackupDays;

    @Parameter(names = { "-VerificationAfterBackup" }, descriptionKey = "cli.smpolicy.command.verificationAfterBackup.option.description")
    private boolean verificationAfterBackup;

    @Parameter(names = { "-VerificationPolicy" }, descriptionKey = "cli.smpolicy.command.verificationPolicy.option.description")
    private String verificationPolicy;

    @Parameter(names = { "-CatalogBackupWithOracleRMAN" }, descriptionKey = "cli.smpolicy.command.catalogBackupWithOracleRMAN.option.description")
    private boolean catalogBackupWithOracleRMAN;

    public OracleBackupType getOracleBackupType() {
        return oracleBackupType;
    }

    public void setOracleBackupType(OracleBackupType oracleBackupType) {
        this.oracleBackupType = oracleBackupType;
    }

    public OracleBackupScope getOracleBackupScope() {
        return oracleBackupScope;
    }

    public void setOracleBackupScope(OracleBackupScope oracleBackupScope) {
        this.oracleBackupScope = oracleBackupScope;
    }

    public boolean isOracleSkipPDBSaveState() {
        return oracleSkipPDBSaveState;
    }

    public void setOracleSkipPDBSaveState(boolean oracleSkipPDBSaveState) {
        this.oracleSkipPDBSaveState = oracleSkipPDBSaveState;
    }

    public boolean isOraclePruneArchiveLog() {
        return oraclePruneArchiveLog;
    }

    public void setOraclePruneArchiveLog(boolean oraclePruneArchiveLog) {
        this.oraclePruneArchiveLog = oraclePruneArchiveLog;
    }

    public OraclePruneArchiveLogType getOraclePruneArchiveLogType() {
        return oraclePruneArchiveLogType;
    }

    public void setOraclePruneArchiveLogType(
            OraclePruneArchiveLogType oraclePruneArchiveLogType) {
        this.oraclePruneArchiveLogType = oraclePruneArchiveLogType;
    }

    public Double getOraclePruneArchiveLogOlderThanDays() {
        return oraclePruneArchiveLogOlderThanDays;
    }

    public void setOraclePruneArchiveLogOlderThanDays(
            double oraclePruneArchiveLogOlderThanDays) {
        this.oraclePruneArchiveLogOlderThanDays = oraclePruneArchiveLogOlderThanDays;
    }

    public OraclePruneArchiveLogDestinationType getOraclePruneArchiveLogDestinationType() {
        return oraclePruneArchiveLogDestinationType;
    }

    public void setOraclePruneArchiveLogDestinationType(
            OraclePruneArchiveLogDestinationType oraclePruneArchiveLogDestinationType) {
        this.oraclePruneArchiveLogDestinationType = oraclePruneArchiveLogDestinationType;
    }

    public boolean isOracleDeleteArchiveLogBackup() {
        return oracleDeleteArchiveLogBackup;
    }

    public void setOracleDeleteArchiveLogBackup(
            boolean oracleDeleteArchiveLogBackup) {
        this.oracleDeleteArchiveLogBackup = oracleDeleteArchiveLogBackup;
    }

    public OracleArchiveLogBackupRetentionType getOracleArchiveLogBackupRetentionType() {
        return oracleArchiveLogBackupRetentionType;
    }

    public void setOracleArchiveLogBackupRetentionType(
            OracleArchiveLogBackupRetentionType oracleArchiveLogBackupRetentionType) {
        this.oracleArchiveLogBackupRetentionType = oracleArchiveLogBackupRetentionType;
    }

    public Integer getOracleDeleteArchiveLogBackupCounts() {
        return oracleDeleteArchiveLogBackupCounts;
    }

    public void setOracleDeleteArchiveLogBackupCounts(
            Integer oracleDeleteArchiveLogBackupCounts) {
        this.oracleDeleteArchiveLogBackupCounts = oracleDeleteArchiveLogBackupCounts;
    }

    public Double getOracleDeleteArchiveLogBackupDays() {
        return oracleDeleteArchiveLogBackupDays;
    }

    public void setOracleDeleteArchiveLogBackupDays(
            double oracleDeleteArchiveLogBackupDays) {
        this.oracleDeleteArchiveLogBackupDays = oracleDeleteArchiveLogBackupDays;
    }

    public boolean isVerificationAfterBackup() {
        return verificationAfterBackup;
    }

    public void setVerificationAfterBackup(boolean verificationAfterBackup) {
        this.verificationAfterBackup = verificationAfterBackup;
    }

    public String getVerificationPolicy() {
        return verificationPolicy;
    }

    public void setVerificationPolicy(String verificationPolicy) {
        this.verificationPolicy = verificationPolicy;
    }

    public void setOraclePruneArchiveLogOlderThanDays(
            Double oraclePruneArchiveLogOlderThanDays) {
        this.oraclePruneArchiveLogOlderThanDays = oraclePruneArchiveLogOlderThanDays;
    }

    public void setOracleDeleteArchiveLogBackupDays(
            Double oracleDeleteArchiveLogBackupDays) {
        this.oracleDeleteArchiveLogBackupDays = oracleDeleteArchiveLogBackupDays;
    }

    public void setCatalogBackupWithOracleRMAN(boolean catalogBackupWithOracleRMAN) {
        this.catalogBackupWithOracleRMAN = catalogBackupWithOracleRMAN;
    }

    public boolean isCatalogBackupWithOracleRMAN() {
        return catalogBackupWithOracleRMAN;
    }
}
