/*
 * $Id: //depot/prod/spl/main/snapcenter-cli/src/main/java/com/netapp/snapcenter/cli/command/parameters/SMOCloneParameters.java#1 $
 * 
 * Copyright (c) 2016 NetApp, Inc.
 * All rights reserved.
 */

package com.netapp.snapcenter.cli.command.parameters;

import com.beust.jcommander.Parameter;
import com.beust.jcommander.Parameters;
import com.netapp.snapcenter.cli.clone.contracts.OracleCloneSpecification;
import com.netapp.snapcenter.cli.command.parser.CommaParameterSplitter;
import com.netapp.snapcenter.cli.command.parser.CustomStringToDateConverter;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

@Parameters(resourceBundle = "snapcenter-cli")
public class SMOCloneParameters implements ParameterInterface {

    public static final String ORACLE_CLONE_SPECIFICATION_FILE_OPTION = "-OracleCloneSpecificationFile";

    @Parameter(names = { "-OracleCloneSpecificationFile" }, descriptionKey = "cli.newsmclone.command.oracleCloneSpecificationFile.option.description")
    private String oracleCloneSpecificationFile;

    @Parameter(names = { "-OracleSkipRecovery" }, descriptionKey = "cli.newsmclone.command.oracleSkipRecovery.option.description")
    private boolean oracleSkipRecovery;

    @Parameter(names = { "-OracleUntilCancel" }, descriptionKey = "cli.newsmclone.command.oracleUntilCancel.option.description")
    private boolean oracleUntilCancel;

    @Parameter(names = { "-OracleUntilScn" }, descriptionKey = "cli.newsmclone.command.oracleUntilScn.option.description")
    private Long oracleUntilScn;

    @Parameter(names = { "-OracleUntilTime" }, descriptionKey = "cli.newsmclone.command.oracleUntilTime.option.description", converter = CustomStringToDateConverter.class)
    private Date oracleUntilTime;

    @Parameter(names = { "-AlternateArchiveLogPaths" }, descriptionKey = "cli.newsmclone.command.alternateArchiveLogPaths.option.description", splitter = CommaParameterSplitter.class)
    private List<String> alternateArchiveLogPaths = new ArrayList<>();

    @Parameter(names = { "-SkipNIDCreation" }, descriptionKey = "cli.newsmclone.command.skipNidCreation.option.description")
    private boolean skipNIDCreation;

	private OracleCloneSpecification oracleCloneSpecification;

    public String getOracleCloneSpecificationFile() {
        return oracleCloneSpecificationFile;
    }

    public void setOracleCloneSpecificationFile(
            String oracleCloneSpecificationFile) {
        this.oracleCloneSpecificationFile = oracleCloneSpecificationFile;
    }

    public OracleCloneSpecification getOracleCloneSpecification() {
        return oracleCloneSpecification;
    }

    public void setOracleCloneSpecification(
            OracleCloneSpecification oracleCloneSpecification) {
        this.oracleCloneSpecification = oracleCloneSpecification;
    }

    public boolean isOracleSkipRecovery() {
        return oracleSkipRecovery;
    }

    public void setOracleSkipRecovery(boolean oracleSkipRecovery) {
        this.oracleSkipRecovery = oracleSkipRecovery;
    }

    public boolean isOracleUntilCancel() {
        return oracleUntilCancel;
    }

    public void setOracleUntilCancel(boolean oracleUntilCancel) {
        this.oracleUntilCancel = oracleUntilCancel;
    }

    public Long getOracleUntilScn() {
        return oracleUntilScn;
    }

    public void setOracleUntilScn(Long oracleUntilScn) {
        this.oracleUntilScn = oracleUntilScn;
    }

    public Date getOracleUntilTime() {
        return oracleUntilTime;
    }

    public void setOracleUntilTime(Date oracleUntilTime) {
        this.oracleUntilTime = oracleUntilTime;
    }

    public void setAlternateArchiveLogPaths(
            List<String> alternateArchiveLogPaths) {
        this.alternateArchiveLogPaths = alternateArchiveLogPaths;
    }

    public List<String> getAlternateArchiveLogPaths() {
        return alternateArchiveLogPaths;
    }

    public boolean isSkipNIDCreation() {
        return skipNIDCreation;
    }

    public void setSkipNIDCreation(boolean skipNIDCreation) {
        this.skipNIDCreation = skipNIDCreation;
    }
}
