/*
 * $Id: //depot/prod/spl/main/snapcenter-cli/src/main/java/com/netapp/snapcenter/cli/command/parser/CustomStringToDateConverter.java#1 $
 * 
 * Copyright (c) 2015 NetApp, Inc.
 * All rights reserved.
 */

package com.netapp.snapcenter.cli.command.parser;

import static com.netapp.snapcenter.cli.utils.CLIUtils.DATE_FORMAT;

import java.text.ParseException;
import java.util.Date;

import org.apache.commons.lang3.time.DateUtils;

import com.beust.jcommander.ParameterException;
import com.beust.jcommander.converters.BaseConverter;
import com.netapp.common.logging.MessageBundle;
import com.netapp.snapcenter.cli.logging.CLIMsgKey;

// TODO: To support all ISO8601 Standard Date Formats.
// TODO: Should handle localization
public class CustomStringToDateConverter extends BaseConverter<Date> {

    public CustomStringToDateConverter(String optionName) {
        super(optionName);
    }

    @Override
    public Date convert(String value) {
        value = value.trim();
        Date date = null;
        try {
            date = DateUtils.parseDateStrictly(value, DATE_FORMAT);
        } catch (ParseException e) {
            String optionName = String.format("\"%s\"", getOptionName());
            String valueInQuotes = String.format("\"%s\"", value);
            String dateConvertError = MessageBundle.localizeMessage(
                    CLIMsgKey.CLI_OPTION_VALUE_TO_DATE_TIME_CONVERSION_FAILED,
                    optionName, valueInQuotes);
            throw new ParameterException(dateConvertError);
        }
        return date;
    }

}
