package com.netapp.snapcenter.cli.command.parser;

import org.apache.commons.lang3.StringUtils;

import com.beust.jcommander.ParameterException;
import com.beust.jcommander.converters.BaseConverter;
import com.netapp.common.logging.MessageBundle;
import com.netapp.snapcenter.cli.logging.CLIMsgKey;

public class CustomStringToLongConverter extends BaseConverter<Long> {

	public CustomStringToLongConverter(String optionName) {
		super(optionName);
	}

	/**
	 * Validates the Long type parameter entered. Throws an exception if the
	 * entered parameter is a decimal or a character.
	 */
	@Override
	public Long convert(String arg0) {
		if (StringUtils.isBlank(arg0)) {
			throw new ParameterException(MessageBundle.localizeMessage(
					CLIMsgKey.PARAMETER_SHOULD_BE_VALID_NUMERICALVALUE,
					getOptionName()));

		}

		long parameter;
		try {
			parameter = Long.parseLong(arg0);
		} catch (NumberFormatException e) {
			throw new ParameterException(MessageBundle.localizeMessage(
					CLIMsgKey.PARAMETER_SHOULD_BE_VALID_NUMERICALVALUE,
					getOptionName()));

		}
		return parameter;
	}

}