/*
 * $Id: //depot/prod/spl/main/snapcenter-cli/src/main/java/com/netapp/snapcenter/cli/command/contracts/AuthMode.java#1 $
 * 
 * Copyright (c) 2015 NetApp, Inc.
 * All rights reserved.
 */

package com.netapp.snapcenter.cli.contracts;

import com.netapp.common.logging.MessageBundle;
import com.netapp.snapcenter.cli.logging.CLIMsgKey;

public enum AuthMode {

	WINDOWS("WINDOWS"), LINUX("LINUX"), ORACLEDATABASE("ORACLE_DATABASE"), ORACLEASM(
			"ORACLE_ASM"), ORACLERMANCATALOG("ORACLE_RMAN_CATALOG");

	private final String value;

	AuthMode(String v) {
		value = v;
	}

	public String value() {
		return value;
	}

	public static AuthMode fromValue(String string) {
		for (AuthMode c : AuthMode.values()) {
			if (c.value.equalsIgnoreCase(string)) {
				return c;
			}
		}
		throw new IllegalArgumentException(
				MessageBundle
						.localizeMessage(
								CLIMsgKey.CLI_ENUM_CONVERSION_INVALID_VALUE,
								string,
								"-AuthMode",
								"[WINDOWS, LINUX, ORACLEDATABASE, ORACLEASM, ORACLERMANCATALOG]"));

	}

}
