/*
 * $Id: //depot/prod/spl/main/snapcenter-cli/src/main/java/com/netapp/snapcenter/cli/command/contracts/OracleBackupScope.java#1 $
 * 
 * Copyright (c) 2015 NetApp, Inc.
 * All rights reserved.
 */
package com.netapp.snapcenter.cli.contracts;

import com.netapp.common.logging.MessageBundle;
import com.netapp.snapcenter.cli.logging.CLIMsgKey;

public enum OracleBackupScope {

    FULL("full"), DATA("data"), LOG("log");

    private final String value;

    OracleBackupScope(String v) {
        value = v;
    }

    public String value() {
        return value;
    }

    public static OracleBackupScope fromValue(String string) {
        for (OracleBackupScope c : OracleBackupScope.values()) {
            if (c.value.equalsIgnoreCase(string)) {
                return c;
            }
        }
        throw new IllegalArgumentException(MessageBundle.localizeMessage(
                CLIMsgKey.CLI_SMPOLICY_INVALID_ORACLE_BACKUP_SCOPE, string));

    }

}
