/*
 * $Id: //depot/prod/spl/main/snapcenter-cli/src/main/java/com/netapp/snapcenter/cli/command/contracts/ScheduleType.java#1 $
 * 
 * Copyright (c) 2015 NetApp, Inc.
 * All rights reserved.
 */

package com.netapp.snapcenter.cli.contracts;

public enum ScheduleType {

    NONE(1, "None"), HOURLY(2, "Hourly"), DAILY(3, "Daily"), WEEKLY(4, "Weekly"), MONTHLY(
            5, "Monthly");

    private final String value;
    private final int intValue;

    ScheduleType(int v, String val) {
        intValue = v;
        value = val;
    }

    public static ScheduleType fromValue(int v) {
        for (ScheduleType c : ScheduleType.values()) {
            if (c.intValue == v) {
                return c;
            }
        }
        throw new IllegalArgumentException();
    }

    public static ScheduleType fromValue(String v) {
        for (ScheduleType c : ScheduleType.values()) {
            if (c.value.equalsIgnoreCase(v)) {
                return c;
            }
        }
        throw new IllegalArgumentException(v);
    }

    public String value() {
        return value;
    }

    public int intValue() {
        return intValue;
    }

}
